#ifndef __INFO_H__
#define __INFO_H__

wchar_t* getipwhere (char *ip);

void GetInnerIP(unsigned long QQUIN, const wchar_t *Type,wchar_t *ip)
{
	TCHAR MYQQ[64];
	wsprintf(MYQQ, L"%X", QQUIN);

	TCHAR buff[256];

	GetPrivateProfileString(Type, MYQQ, L"", buff, 255, tzCachePath);
	if (wcscmp(buff, L"") != 0)
	{
		wcscpy(ip, buff);
	}
	else
	{
		wcscpy(ip, L"δ̽Էַ");
	}
}
void GetWANIP(unsigned long QQUIN, wchar_t *wanip)
{
    GetInnerIP(QQUIN,L"WAN",wanip);
}

void GetLANIP(unsigned long QQUIN, wchar_t *lanip)
{
	GetInnerIP(QQUIN,L"LAN",lanip);
}

void GetTime(unsigned long QQUIN, wchar_t *time)
{
	TCHAR MYQQ[64];
	wsprintf(MYQQ, L"%X", QQUIN);

	TCHAR buff[256];

	GetPrivateProfileString(L"TIME", MYQQ, L"", buff, 255, tzCachePath);
	if (wcscmp(buff, L"") != 0)
	{
		wcscpy(time, buff);
	}
	else
	{
		wcscpy(time, L"δ̽");
	}
}

void GetTime2(unsigned long QQUIN, wchar_t *time)
{
	TCHAR MYQQ[64];
	wsprintf(MYQQ, L"%X", QQUIN);

	TCHAR buff[256];

	GetPrivateProfileString(L"TIME", MYQQ, L"", buff, 255, tzCachePath);
	if (wcscmp(buff, L"") != 0)
	{
        int year,month,day;
        swscanf(buff,L"%4d%2d%2d",&year,&month,&day);
		wsprintf(time,L"%04d.%02d.%02d",year,month,day);
	}
	else
	{
		wcscpy(time, L"δ̽");
	}
}

void GetAddress(unsigned long QQUIN, wchar_t *address)
{
	TCHAR MYQQ[64];
	wsprintf(MYQQ, L"%X", QQUIN);

	TCHAR tzWanIP[256];
	GetPrivateProfileString(L"WAN", MYQQ, L"", tzWanIP, 255, tzCachePath);
	if (wcscmp(tzWanIP, L"") != 0)
	{
		TCHAR tzTime[128];
		GetTime(QQUIN, tzTime);

		SYSTEMTIME SystemTime;
		GetLocalTime(&SystemTime);
		wsprintf(MYQQ, _T("%04d%02d%02d"), SystemTime.wYear, SystemTime.wMonth, SystemTime.wDay);

		if (wcscmp(tzTime, MYQQ) != 0) //жǷյַ
		{
			wcscpy(address, L"*");
		}
		else
		{
			wcscpy(address, L"");
		}
		
        wchar_t *wryaddress = getipwhere(Unicode2Ansi(tzWanIP));
        if (wcscmp(wryaddress, L"") != 0)
        {
            wcscat(address, wryaddress);
            return;
        }
        
		TCHAR buff1[256];
		TCHAR buff2[256];
		TCHAR buff3[256];

		GetPrivateProfileString(L"QQ", tzWanIP, L"", buff1, 255, tzQQWryPath);
		GetPrivateProfileString(L"MY", tzWanIP, L"", buff2, 255, tzQQWryPath);
		GetPrivateProfileString(L"IP", tzWanIP, L"", buff3, 255, tzQQWryPath);
		if (wcscmp(buff1, L"") != 0 || wcscmp(buff2, L"") != 0 || wcscmp(buff3, L"") != 0)
		{
			if (wcslen(buff1) > wcslen(buff2)) wcscpy(buff2, buff1);//ַ
			if (wcslen(buff3) > wcslen(buff2)) wcscpy(buff2, buff3);//ַ
			wcscat(address, buff2);
		}
		else
		{
			wcscat(address, tzWanIP);
		}
	}
	else
	{
		wcscpy(address, L"δ̽⣬ͼ̽");
	}
	//if(wcslen(address)>17) address[17]=0;
}

void GetAddressInner(unsigned long QQUIN, const wchar_t *Type,wchar_t *address)
{
	TCHAR tzWanIP[128];
	GetWANIP(QQUIN, tzWanIP);

	TCHAR buff[256];

	GetPrivateProfileString(Type, tzWanIP, L"", buff, 255, tzQQWryPath);
	if (wcscmp(buff, L"") != 0)
	{
		wcscpy(address, buff);
	}
	else
	{
		wcscpy(address, L"δѯ");
	}
	//DbgPrint(L"%s %d",address,wcslen(address));
	//if(wcslen(address)>17) address[17]=0;
}

void GetAddress1(unsigned long QQUIN, wchar_t *address)
{
	GetAddressInner(QQUIN,L"QQ", address);
}

void GetAddress2(unsigned long QQUIN, wchar_t *address)
{
	GetAddressInner(QQUIN,L"MY", address);
}

void GetAddress3(unsigned long QQUIN, wchar_t *address)
{
	GetAddressInner(QQUIN,L"IP", address);
}

void GetAddress4(unsigned long QQUIN, wchar_t *address4)
{
	TCHAR MYQQ[64];
	wsprintf(MYQQ, L"%X", QQUIN);

	TCHAR tzWanIP[256];
	GetPrivateProfileString(L"WAN", MYQQ, L"", tzWanIP, 255, tzCachePath);
	if (wcscmp(tzWanIP, L"") != 0)
	{
		wchar_t *wryaddress = getipwhere(Unicode2Ansi(tzWanIP));
		if (wcscmp(wryaddress, L"") != 0)
		{
            wcscpy(address4, wryaddress);
            return;
		}
	}
	
	wcscpy(address4, L"δѯ");
}
void QueryInfo(unsigned long QQUIN, wchar_t *tzTips, int mode)
{
	TCHAR tzNumber[256];
	wsprintf(tzNumber, L"%d", QQUIN);
	
	TCHAR tzVersion[256];
	GetVersion(QQUIN, tzVersion);
    if(wcsstr(tzVersion,L"δ֪汾"))
    {
        _beginthread(QueryVersionFromNet,0,(void*)WORD2BB(Util::Contact::GetIMVersion(QQUIN)));
    }
	TCHAR tzWanIP[256];
	GetWANIP(QQUIN, tzWanIP);

	TCHAR tzLanIP[256];
	GetLANIP(QQUIN, tzLanIP);

	TCHAR tzTime[256];
	GetTime2(QQUIN, tzTime);

	TCHAR tzAddress[256];
	GetAddress(QQUIN, tzAddress);

	TCHAR tzAddress1[256];
	GetAddress1(QQUIN, tzAddress1);

	TCHAR tzAddress2[256];
	GetAddress2(QQUIN, tzAddress2);

	TCHAR tzAddress3[256];
	GetAddress3(QQUIN, tzAddress3);

	TCHAR tzAddress4[256];
	GetAddress4(QQUIN, tzAddress4);
	

	if (mode) GetPrivateProfileString(L"ʾʽ", L"", L"%V | %L\n%D", tzTips, 1024, tzIniPath);
	else GetPrivateProfileString(L"ʾʽ", L"", L"Է룺%U\nԷ汾%V\nַ%W\nַ%L\nʱ䣺%T\n߲ѯ1%Q\n߲ѯ2%M\n߲ѯ3%I", tzTips, 1024, tzIniPath);

	wchar_t *ln = replace(tzTips, L"\\n", L"\n");

	wchar_t *t1 = replace(ln, L"%V", tzVersion);
	wchar_t *t2 = replace(t1, L"%W", tzWanIP);
	wchar_t *t3 = replace(t2, L"%L", tzLanIP);
	wchar_t *t4 = replace(t3, L"%T", tzTime);
	wchar_t *t5 = replace(t4, L"%D", tzAddress);
	wchar_t *t6 = replace(t5, L"%Q", tzAddress1);
	wchar_t *t7 = replace(t6, L"%M", tzAddress2);
	wchar_t *t8 = replace(t7, L"%I", tzAddress3);
	wchar_t *t9 = replace(t8, L"%B", tzAddress4);
	wchar_t *t10 = replace(t9, L"%U", tzNumber);
	free(ln);
	free(t1);
	free(t2);
	free(t3);
	free(t4);
	free(t5);
	free(t6);
	free(t7);
	free(t8);
	free(t9);
	wcsncpy(tzTips, t10, 4096);
	tzTips[4096]=0;
	free(t10);
	
	trim(tzTips);
}

void GetBarAddress(unsigned long QQUIN, wchar_t *BarAddress,int mode)
{
	TCHAR tzWanIP[256];
	GetWANIP(QQUIN, tzWanIP);
	
	TCHAR tzAddress[256];
	GetAddress(QQUIN, tzAddress);

	TCHAR tzAddress1[256];
	GetAddress1(QQUIN, tzAddress1);

	TCHAR tzAddress2[256];
	GetAddress2(QQUIN, tzAddress2);

	TCHAR tzAddress3[256];
	GetAddress3(QQUIN, tzAddress3);

	TCHAR tzAddress4[256];
	GetAddress4(QQUIN, tzAddress4);
	
	if (mode==1) GetPrivateProfileString(L"ʾλ", L"½Ǹʽ", L"%D", BarAddress, 255, tzIniPath);
	else GetPrivateProfileString(L"ʾλ", L"ϽǸʽ", L"%D", BarAddress, 255, tzIniPath);


	wchar_t *t4 = replace(BarAddress, L"%D", tzAddress);
	wchar_t *t5 = replace(t4, L"%W", tzWanIP);
	wchar_t *t6 = replace(t5, L"%Q", tzAddress1);
	wchar_t *t7 = replace(t6, L"%M", tzAddress2);
	wchar_t *t8 = replace(t7, L"%I", tzAddress3);
	wchar_t *t9 = replace(t8, L"%B", tzAddress4);
	free(t4);
	free(t5);
	free(t6);
	free(t7);
	free(t8);

	wcsncpy(BarAddress, t9, 255);
	BarAddress[255]=0;
	
	unsigned int length = 17;
	if(BarAddress[0]==L'*') length++;
	if(wcslen(BarAddress)>length) BarAddress[length]=0;
	free(t9);
	
	trim(BarAddress);
}
#endif // __INFO_H__
